diff --git a/v1.hs b/v1.hs
index 45c6278..67bc482 100644
--- a/v1.hs
+++ b/v1.hs
@@ -1,5 +1,6 @@
 module Main where
 
+import Control.Monad (forever)
 import Data.List (transpose, findIndex)
 
 type Board = [[Int]]
@@ -41,11 +42,13 @@ replace i v list = before ++ v:after
 
 -- Given a valid initial board find a solved board
 solve :: Board -> [Board]
-solve board | complete board = if valid board then [board] else []
+solve board | not (valid board) = []
+            | complete board = if valid board then [board] else []
             | otherwise = concat [solve (setAt (firstZero board) i board) | i <- [1..9] ]
 
-main = do
-  inLines <- sequence (map (\_ -> getLine) [0..8])
+main = forever $ do
+  getLine >>= putStrLn -- dump name
+  inLines <- sequence (map (\_ -> fmap (filter (/= '\r')) getLine) [0..8])
   let board = map (map (\c -> read [c])) inLines :: Board
   print board
   print (solve board)
